if select(2, UnitClass("player")) ~= "PALADIN" then return end
local BS = AceLibrary("Babble-Spell-2.2");

--No base increase: Avenger's Shield, Holy Shield, Consecration, Holy Wrath

function DrDamage:PlayerData()

	--Special calculation
	DrDamage.Calculation["Crusade"] = function( calculation, talentValue )
		if not calculation.healingSpell then
			if UnitCreatureType( "target" ) == "Undead"
			or UnitCreatureType( "target" ) == "Demon"
			or UnitCreatureType( "target" ) == "Humanoid"
			or UnitCreatureType( "target" ) == "Elemental" then
				calculation.dmgM = calculation.dmgM * ( 1 + talentValue )
			end
		end
	end
	DrDamage.Calculation["Improved Holy Shield"] = function( calculation, talentValue )
		if calculation.sHits then
			calculation.sHits = calculation.sHits + talentValue
		end
	end
	DrDamage.Calculation["One-Handed Weapon Specialization"] = function( calculation, talentValue )
		if not calculation.healingSpell then
			if IsEquippedItemType( "One-Handed Axes" ) or IsEquippedItemType( "One-Handed Maces" ) or IsEquippedItemType( "One-Handed Swords"  ) then
				calculation.dmgM = calculation.dmgM * ( 1 + talentValue )
			end
		end
	end
	DrDamage.Calculation["Crusader Strike"] = function( calculation )
		local rangeMin, rangeMax, _, _, _, _, percMod = UnitDamage( "player" )
		local atkPower = DrDamage:TotalAP()
		local baseMin = rangeMin / percMod - ( atkPower / 14 ) * UnitAttackSpeed( "player" )
		local baseMax = rangeMax / percMod - ( atkPower / 14 ) * UnitAttackSpeed( "player" )
		local normM
			
		if IsEquippedItemType( "One-Handed Axes" ) or IsEquippedItemType( "One-Handed Maces" ) or IsEquippedItemType( "One-Handed Swords"  ) then
			normM = 2.4
		else
			normM = 3.3
		end
			
		calculation.minDam = baseMin + ( atkPower / 14 ) * normM
		calculation.maxDam = baseMax + ( atkPower / 14 ) * normM
	end
	DrDamage.Calculation["Seal of Vengeance"] = function( calculation, ActiveAuras )
		if ActiveAuras["Seal of Vengeance"] then
			calculation.bDmgM = calculation.bDmgM + ( ActiveAuras["Seal of Vengeance"] - 1 )
		end
	end
	DrDamage.Calculation["Holy Light"] = function( calculation, ActiveAuras )
		if ActiveAuras["Blessing of Light"] or ActiveAuras["Greater Blessing of Light"] then
			if IsEquippedItem( 28592 ) then
				calculation.finalMod = calculation.finalMod + 105
			end
		end
	end
	DrDamage.Calculation["Flash of Light"] = DrDamage.Calculation["Holy Light"]
	DrDamage.Calculation["PALADIN"] = function( calculation, ActiveAuras, BuffTalentRanks )
		if ActiveAuras["Judgement of the Crusader"] then
			if IsEquippedItem( 23203 ) then						--Libram of Fervor
				ActiveAuras["Judgement of the Crusader"] = ActiveAuras["Judgement of the Crusader"] + 33
			elseif IsEquippedItem( 27983 ) or IsEquippedItem( 27949 ) then		--Libram of Zeal
				ActiveAuras["Judgement of the Crusader"] = ActiveAuras["Judgement of the Crusader"] + 48					
			end

			if BuffTalentRanks["Improved Seal of the Crusader"] then
				ActiveAuras["Judgement of the Crusader"] = ActiveAuras["Judgement of the Crusader"] * ( 1 + 0.05 * BuffTalentRanks["Improved Seal of the Crusader"] )
			end

			if BuffTalentRanks["Sanctified Crusader"] then
				calculation.critPerc = calculation.critPerc + BuffTalentRanks["Sanctified Crusader"]
			end
			
			calculation.spellDmg = calculation.spellDmg + ActiveAuras["Judgement of the Crusader"]		
		end
	end
	DrDamage.Calculation["Vengeance"] = function( calculation, _, BuffTalentRanks, _, apps )
		if apps and BuffTalentRanks["Vengeance"] then
			calculation.dmgM = calculation.dmgM * ( 1 + 0.01 * BuffTalentRanks["Vengeance"] * apps )
		end
	end
	DrDamage.Calculation["Revenge"] = DrDamage.Calculation["Vengeance"]
	DrDamage.Calculation["Sanctity Aura"] = function( calculation, _, BuffTalentRanks )
		if BuffTalentRanks["Improved Sanctity Aura"] then
			if calculation.spellSchool == "Holy" then
				calculation.dmgM = calculation.dmgM * ( 1.1 + 0.01 * BuffTalentRanks["Improved Sanctity Aura"] )
			else
				calculation.dmgM = calculation.dmgM * ( 1 + 0.01 * BuffTalentRanks["Improved Sanctity Aura"] )
			end
		else
			if calculation.spellSchool == "Holy" then
				calculation.dmgM = calculation.dmgM * 1.1
			end
		end
	end
	
	--Relic slot items
	DrDamage.RelicSlot["Consecration"] = { 27917, 47 }				--Libram of the Eternal Rest
	DrDamage.RelicSlot["Crusader Strike"] = { 31033, 18, ModType1 = "Final" }	--Libram of Righteous Power
	DrDamage.RelicSlot["Flash of Light"] = { 23006, 83, 25644, 79, 23201, 53, }	--Libram of Light, Blessed Book of Nagrand, Libram of Divinity	
	DrDamage.RelicSlot["Holy Light"] = { 28296, 87, }				--Libram of the Lightbringer
	
	--Set bonuses
	
	--Sets
	DrDamage.SetBonuses["Justicar Armor"] = { 29066, 29067, 29068, 29069, 29070 }
	DrDamage.SetBonuses["Justicar Battlegear"] = { 29071, 29072, 29073, 29074, 29075 }
	DrDamage.SetBonuses["Crystalforge Raiment"] = { 30134, 30135, 30136, 30137, 30138 }
	
	--Effects
	DrDamage.SetBonuses["Holy Shield"] = function( calculation )
		if DrDamage:GetSetAmount( "Justicar Armor" ) >= 4 then
			calculation.dmgM = calculation.dmgM * 1.15
		end
	end
	DrDamage.SetBonuses["PALADIN"] = function( calculation, ActiveAuras )
		if DrDamage:GetSetAmount( "Justicar Battlegear" ) >= 2 then
			if ActiveAuras["Judgement of the Crusader"] then
				ActiveAuras["Judgement of the Crusader"] = ActiveAuras["Judgement of the Crusader"] * 1.15
			end
		end
	end
	DrDamage.SetBonuses["Seal of Command"] = function( calculation )
		if DrDamage:GetSetAmount( "Justicar Battlegear" ) >= 4 then
			calculation.dmgM = calculation.dmgM * 1.1
		end
	end
	DrDamage.SetBonuses["Holy Light"] = function( calculation )
		if DrDamage:GetSetAmount( "Crystalforge Raiment" ) >= 4 then
			calculation.castTime = calculation.castTime - 0.25
		end
	end	
	
	--Auras
	if DrDamage.HealingBuffs and DrDamage.PlayerAura and DrDamage.Debuffs then
		DrDamage.HealingBuffs["Blessing of Light"] = { ModType = "RankTable2", Ranks = 4, Spell = { BS["Flash of Light"], BS["Holy Light"] }, Value = { 60, 85, 115, 185 }, Value2 = { 210, 300, 400, 580, }, ActiveAura = true }
		DrDamage.HealingBuffs["Greater Blessing of Light"] = { ModType = "RankTable2", Ranks = 2, Spell = { BS["Flash of Light"], BS["Holy Light"] }, Value = { 115, 185 }, Value2 = { 400, 580, }, ActiveAura = true }	
	
		DrDamage.PlayerAura["Sanctity Aura"] = { ModType = "Special" }	
		DrDamage.PlayerAura["Vengeance"] = { School = { "Holy", "Physical" }, ModType = "Special" }	
		DrDamage.PlayerAura["Revenge"] = { School = { "Holy", "Physical" }, ModType = "Special" }	
		DrDamage.PlayerAura["Light's Grace"] = { Value = -0.5, ModType = "CastTime", Spell = BS["Holy Light"], }
		DrDamage.PlayerAura["Avenging Wrath"] = { Value = 0.3 }
		DrDamage.PlayerAura["Divine Favor"] = { Spell = { BS["Flash of Light"], BS["Holy Light"], BS["Holy Shock"], }, ModType = "Crit", Value = 100, }
		
		DrDamage.Debuffs["Seal of Vengeance"] = { ModType = "ActiveAura", Spell = BS["Seal of Vengeance"], ActiveAura = true }
		DrDamage.Debuffs["Judgement of the Crusader"] = { ModType = "JotC", School = { "Holy", "Physical" }, Ranks = 7, Value = { 20, 30, 50, 80, 110, 140, 190 }, }
		
		DrDamage.Debuffs["Intercept Stun"] = 		{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Starfire Stun"] = 		{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Stun"] = 			{ Stun = true, Spell = BS["Seal of Command"], } 
		DrDamage.Debuffs["Bash"] = 			{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Blackout"] = 			{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Hammer of Justice"] = 	{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Charge Stun"] = 		{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Concussion Blow"] = 		{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Cheap Shot"] = 		{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Gouge"] = 			{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Impact"] = 			{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Kidney Shot"] = 		{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Maim"] = 			{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Pounce"] = 			{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Sap"] = 			{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["War Stomp"] = 		{ Stun = true, Spell = BS["Seal of Command"], }
		DrDamage.Debuffs["Feral Charge Effect"]= 	{ Stun = true, Spell = BS["Seal of Command"], }
	end
	
	DrDamage.spellInfo = { 
		[BS["Crusader Strike"]] = { 
					[0] = { School = { "Holy", "Physical" }, bonusFactor = 0.4, Cooldown = 10, NoSchoolBuffs = true },
					["None"] = { 0, 0, spellLevel = 50, },
					[1] = { 0, 0, spellLevel = 50, },
		},
		[BS["Avenger's Shield"]] = { 
					[0] = { School = { "Holy", "Physical" }, canCrit = true, castTime = 1, sFactor = 1/2, chainFactor = 1, Cooldown = 30, },
					[1] = { 270, 330, spellLevel = 50, },
					[2] = { 370, 452, spellLevel = 60, }, 
					[3] = { 494, 602, spellLevel = 70, }, 
		},
		[BS["Holy Wrath"]] = { 
					[0] = { School = "Holy", canCrit = true, castTime = 2, sFactor = 1/2, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 362, 428, 6, 7, spellLevel = 50, },
					[2] = { 490, 576, 7, 8, spellLevel = 60, },
					[3] = { 635, 745, 2, 3, spellLevel = 69, },
		},
		[BS["Holy Shield"]] = { 
					[0] = { School = "Holy", Instant = true, bonusFactor = 0.20, NoDPS = true, NoDoom = true, sHits = 4, },
					[1] = { 59, 59, spellLevel = 40, },
					[2] = { 86, 86, spellLevel = 50, },
					[3] = { 117, 117, spellLevel = 60, },
					[4] = { 155, 155, spellLevel = 70, },
		},
		[BS["Holy Light"]] = { 
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 2.5, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 39, 47, 3, 4, spellLevel = 1, },
					[2] = { 76, 90, 5, 6, spellLevel = 6, },
					[3] = { 159, 187, 8, 9, spellLevel = 14, },
					[4] = { 310, 356, 12, 12, spellLevel = 22, },
					[5] = { 491, 553, 15, 16, spellLevel = 30, },
					[6] = { 698, 780, 19, 19, spellLevel = 38, },
					[7] = { 945, 1053, 23, 23, spellLevel = 46, },
					[8] = { 1246, 1388, 26, 26, spellLevel = 54, },
					[9] = { 1590, 1770, 29, 29, spellLevel = 60, },
					[10] = { 1741, 1939, 32, 32, spellLevel = 62, },
					[11] = { 2196, 2446, 0, 0, spellLevel = 70, },
		},	
		[BS["Hammer of Wrath"]] = {
					[0] = { School = { "Holy", "Physical" }, canCrit = true, Cooldown = 6, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 304, 336, 12, 12, spellLevel = 44, },
					[2] = { 399, 441, 13, 14, spellLevel = 52, },
					[3] = { 504, 556, 15, 16, spellLevel = 60, },
					[4] = { 665, 735, 7, 7, spellLevel = 68, }, --Check increase
		},
		[BS["Exorcism"]] = {
					[0] = { School = "Holy", Instant = true, canCrit = true, Cooldown = 15, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 84, 96, 6, 6, spellLevel = 20, },
					[2] = { 152, 172, 8, 8, spellLevel = 28, },
					[3] = { 217, 245, 10, 10, spellLevel = 36, },
					[4] = { 304, 342, 12, 12, spellLevel = 44, },
					[5] = { 393, 439, 14, 14, spellLevel = 52, },
					[6] = { 505, 563, 16, 16, spellLevel = 60, },
					[7] = { 619, 691, 7, 7, spellLevel = 68, },
		},
		[BS["Consecration"]] = {
					--sFactor = 1/2 * 0.83?
					[0] = { School = "Holy", castTime = 8, sFactor = 1/3, sTicks = 1, },
					[1] = { 64, 64, spellLevel = 20, },
					[2] = { 120, 120, spellLevel = 30, },
					[3] = { 192, 192, spellLevel = 40, },
					[4] = { 280, 280, spellLevel = 50, },
					[5] = { 384, 384, spellLevel = 60, },
					[6] = { 512, 512, spellLevel = 70, },
		},
		[BS["Flash of Light"]] = { 
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 1.5, BaseIncrease = true, LevelIncrease = 5 },
					[1] = { 62, 72, 5, 5, spellLevel = 20, },
					[2] = { 96, 110, 6, 7, spellLevel = 26, },
					[3] = { 145, 163, 8, 9, spellLevel = 34, },
					[4] = { 197, 221, 9, 10, spellLevel = 42, },
					[5] = { 267, 299, 11, 11, spellLevel = 50, },
					[6] = { 343, 383, 13, 13, spellLevel = 58, },
					[7] = { 448, 502, 10, 11, spellLevel = 66, },
		},
		[BS["Holy Shock"]] = { 
					[0] = { School = "Holy", Instant = true, canCrit = true, Cooldown = 15, },
					[1] = { 204, 220, spellLevel = 40, },
					[2] = { 279, 301, spellLevel = 48, },
					[3] = { 365, 395, spellLevel = 56, },
					[4] = { 452, 488, spellLevel = 64, },
					[5] = { 530, 574, spellLevel = 70, },
		},
		--Judgements:
		[BS["Seal of Righteousness"]] = {
					[0] = { School = { "Holy", "Judgement" }, Instant = true, bonusFactor = 0.73, canCrit = true, NoDPM = true, NoDoom = true, BaseIncrease = true, LevelIncrease = 6 },
					[1] = { 15, 15, 10, 11, spellLevel = 1,  },
					[2] = { 25, 27, 11, 12, spellLevel = 10, },
					[3] = { 39, 43, 14, 15, spellLevel = 18, },
					[4] = { 57, 63, 16, 17, spellLevel = 26, },
					[5] = { 78, 86, 18, 19, spellLevel = 34, },
					[6] = { 102, 112, 22, 23, spellLevel = 42, },	
					[7] = { 131, 143, 24, 25, spellLevel = 50, },
					[8] = { 162, 178, 24, 25, spellLevel = 58, },
					[9] = { 208, 228, 17, 18, spellLevel = 66, }, 
		},
		[BS["Seal of Command"]] = {
					[0] = { School = { "Holy", "Judgement", "Physical" }, Instant = true, canCrit = true, NoDPM = true, NoDoom = true, BaseIncrease = true, LevelIncrease = 7 },
					[1] = { 46, 50, 22, 23, spellLevel = 20, },
					[2] = { 73, 80, 24, 25, spellLevel = 30, },
					[3] = { 102, 112, 22, 23, spellLevel = 40, },
					[4] = { 130, 143, 24, 25, spellLevel = 50, },
					[5] = { 169, 186, 24, 25, spellLevel = 60, },
					[6] = { 228, 252, 0, 0, spellLevel = 70, },
		},
		[BS["Seal of Vengeance"]] = {
					[0] = { School = { "Holy", "Judgement" }, Instant = true, canCrit = true, NoDPM = true, NoDoom = true, },
					[1] = { 120, 120, spellLevel = 64, },			
		},
		[BS["Seal of Blood"]] = {
					[0] = { School = { "Holy", "Judgement", "Physical" }, Instant = true, canCrit = true, NoDPM = true, NoDoom = true, BaseIncrease = true, },
					[1] = { 295, 325, 36, 37, spellLevel = 64, },			
		},
		[BS["Gift of the Naaru"]] = {
					[0] = { School = { "Holy", "Healing" }, Cooldown = 180, castTime = 1.5, eDot = true, eDuration = 15, sTicks = 3, bonusFactor = 1, BaseIncrease = true, NoLowLevelPenalty = true, },
					["None"] = { 50, 50, 1035, 1035, spellLevel = 1, },
		},			
	}
	DrDamage.talentInfo = { 
		--Holy:
		["Improved Seal of Righteousness"] = { 	[1] = { Effect = 0.03, Spells = "Seal of Righteousness", }, },
		["Healing Light"] = { 			[1] = { Effect = 0.04, Spells = { "Holy Light", "Flash of Light", }, }, },
		["Sanctified Light"] = { 		[1] = { Effect = 2, Spells = "Holy Light", ModType = "Crit" }, },
		["Improved Seal of the Crusader"] = { 	[1] = { Effect = 1, Spells = "Holy", ModType = "BuffTalentRanks" }, },
		["Illumination"] = { 			[1] = { Effect = 0.12, Spells = { "Holy Light", "Flash of Light", "Holy Shock" }, ModType = "FreeCrit" }, },
		["Purifying Power"] = {			[1] = { Effect = 10, Spells = { "Holy Wrath", "Exorcism", }, ModType = "Crit" }, },
		--Retribution:
		["Crusade"] = { 			[1] = { Effect = 0.01, Spells = "All", ModType = "Crusade" }, },
		["Vengeance"] = { 			[1] = { Effect = 1, Spells = "Holy", ModType = "BuffTalentRanks", }, },
		["Sanctified Crusader"] = { 		[1] = { Effect = 1, Spells = "All", ModType = "BuffTalentRanks" }, },
		["Improved Sanctity Aura"] = { 		[1] = { Effect = 1, Spells = "All", ModType = "BuffTalentRanks" }, },
		["Fanaticism"] = { 			[1] = { Effect = 3, Spells = "Judgement", ModType = "Crit" }, },
		["Improved Holy Shield"] = { 		[1] = { Effect = 0.1, Spells = "Holy Shield", },
							[2] = { Effect = 2, Spells = "Holy Shield", ModType = "Improved Holy Shield" },
		},
		["One-Handed Weapon Specialization"] = { [1] = { Effect = 0.01, Spells = "All", ModType = "One-Handed Weapon Specialization" }, },
	}
end