if select(2, UnitClass("player")) ~= "ROGUE" then return end
local BS = AceLibrary("Babble-Spell-2.2")

function DrDamage:PlayerData()

	--Special calculation
	DrDamage.Calculation["Murder"] = function( calculation, talentValue )
		if not calculation.healingSpell then
			if UnitCreatureType( "target" ) == "Humanoid"
			or UnitCreatureType( "target" ) == "Giant"
			or UnitCreatureType( "target" ) == "Beast"
			or UnitCreatureType( "target" ) == "Dragonkin" then
				calculation.dmgM = calculation.dmgM * ( 1 + talentValue )
			end
		end
	end
	
	DrDamage.spellInfo = {
		[BS["Sinister Strike"]] = {
			[0] = { Energy = 45, WeaponDamage = 1 },
			[1] = { 3 },
			[2] = { 6 },
			[3] = { 10 },
			[4] = { 15 },
			[5] = { 22 },
			[6] = { 33 },
			[7] = { 52 },
			[8] = { 68 },
			[9] = { 80 },
			[10] = { 98 },
		},
		[BS["Backstab"]] = {
			[0] = { Energy = 60, WeaponDamage = 1.5 },
			[1] = { 15 },
			[2] = { 30 },
			[3] = { 48 },
			[4] = { 69 },
			[5] = { 90 },
			[6] = { 135 },
			[7] = { 165 },
			[8] = { 210 },
			[9] = { 225 },
			[10] = { 255 },
		},
		[BS["Eviscerate"]] = {
			[0] = { Energy = 35, ComboPoints = true, APBonus = 0.03 },
			[1] = { 6, 10, PerCombo = 5 },
			[2] = { 14, 22, PerCombo = 11 },
			[3] = { 25, 39, PerCombo = 19 },
			[4] = { 41, 61, PerCombo = 31 },
			[5] = { 60, 90, PerCombo = 45 },
			[6] = { 93, 137, PerCombo = 71 },
			[7] = { 144, 212, PerCombo = 110 },
			[8] = { 199, 295, PerCombo = 151 },
			[9] = { 224, 332, PerCombo = 170 },
			[10] = { 245, 365, PerCombo = 185 },
		},
		[BS["Ambush"]] = {
			[0] = { Energy = 60, WeaponDamage = 2.5 },
			[1] = { 70 },
			[2] = { 100 },
			[3] = { 125 },
			[4] = { 185 },
			[5] = { 230 },
			[6] = { 290 },
			[7] = { 335 },
		},
		[BS["Gouge"]] = {
			[0] = { Energy = 45, Cooldown = 10 },
			[1] = { 10 },
			[2] = { 20 },
			[3] = { 32 },
			[4] = { 55 },
			[5] = { 75 },
			[6] = { 105 },
		},
		[BS["Ghostly Strike"]] = {
			[0] = { Energy = 40, WeaponDamage = 1.25, Cooldown = 20, NoNormalization = true },
			[1] = { 0 },
		},
		[BS["Riposte"]] = {
			[0] = { Energy = 10, WeaponDamage = 1.5, NoNormalization = true },
			[1] = { 0 },
		},
		[BS["Garrote"]] = {
			[0] = { Energy = 50, NoCrits = true, APBonus = 0.18, eDuration = 18, Ticks = 3 },
			[1] = { 144 },
			[2] = { 204 },
			[3] = { 282 },
			[4] = { 354 },
			[5] = { 444 },
			[6] = { 552 },
			[7] = { 666 },
			[8] = { 810 },
		},
		[BS["Rupture"]] = {
			[0] = { Energy = 25, NoCrits = true, ComboPoints = true, APBonus = { 0.04, 0.10, 0.18, 0.21, 0.24 }, ExtraPerCombo = { 0, 0, 1, 3, 6 }, eDuration = 6, DurationPerCombo = 2 },
			[1] = { 40, PerCombo = 20, Extra = 4 },
			[2] = { 60, PerCombo = 30, Extra = 6 },
			[3] = { 88, PerCombo = 42, Extra = 8 },
			[4] = { 128, PerCombo = 57, Extra = 10 },
			[5] = { 176, PerCombo = 79, Extra = 14 },
			[6] = { 272, PerCombo = 108, Extra = 16 },
			[7] = { 324, PerCombo = 136, Extra = 22 },
		},
		[BS["Hemorrhage"]] = {
			[0] = { Energy = 35, WeaponDamage = 1, NoNormalization = true },
			[1] = { 0 },
			[2] = { 0 },
			[3] = { 0 },
			[4] = { 0 },
		},
		[BS["Envenom"]] = {
			[0] = { School = "Nature", Energy = 35, ComboPoints = true, APBonus = 0.03 },
			[1] = { 144, PerCombo = 144 },
			[2] = { 180, PerCombo = 180 },
		},
		[BS["Deadly Throw"]] = {
			[0] = { School = "Ranged", WeaponDamage = 1, Energy = 35, ComboPoints = true, APBonus = 0.03 },
			[1] = { 164, 180, PerCombo = 105 },
		},
		[BS["Mutilate"]] = {
			[0] = { Energy = 60, WeaponDamage = 1, DualAttack = true },
			[1] = { 44 },
			[2] = { 63 },
			[3] = { 88 },
			[4] = { 101 },
		},
	}	
	DrDamage.talentInfo = {
		--Assassination:
	--	["Find Weakness"] = {		[1] = { Effect = 1, Spells = "Finisher", ModType = "BuffTalentRanks" }, },
		["Improved Backstab"] = {	[1] = { Effect = 10, Spells = "Backstab", ModType = "Crit" }, },
		["Improved Eviscerate"] = {	[1] = { Effect = 0.05, Spells = "Eviscerate" }, },
		["Lethality"] = {			[1] = { Effect = 0.06, Spells = { "Sinister Strike", "Gouge", "Backstab", "Ghostly Strike", "Mutilate", "Shiv", "Hemorrhage" }, ModType = "CritMultiplier" }, },
		["Murder"] = {				[1] = { Effect = 0.01, Spells = "All", ModType = "Murder" }, },
	--	["Remorseless Attacks"] = {	[1] = { Effect = 20, Spells = { "Sinister Strike", "Hemorrhage", "Backstab", "Mutilate", "Ambush", "Ghostly Strike" }, ModType = "BuffTalentRanks" }, },
		["Vile Poisons"] = {		[1] = { Effect = 0.04, Spells = "Envenom" }, },
		--Combat:
		["Aggression"] = {			[1] = { Effect = 0.02, Spells = { "Sinister Strike", "Eviscerate" }, }, },
	--	["Improved Sinister Strike"] = { [1] = { Effect = { 2, 3 }, Spells = "Sinister Strike", ModType = "Energy" }, },
		["Surprise Attacks"] = {	[1] = { Effect = 0.1, Spells = { "Sinister Strike", "Backstab", "Shiv", "Gouge" }, }, },
		--Subtlety:
		["Improved Ambush"] = {		[1] = { Effect = 15, Spells = "Ambush", ModType = "Crit" }, },
		["Opportunity"] = {			[1] = { Effect = 0.04, Spells = { "Backstab", "Mutilate", "Garrote", "Ambush" }, }, },
		["Serrated Blades"] = {		[1] = { Effect = 0.1, Spells = "Rupture" }, },
	}
end